function [I,Bn,par] = Gen_Blur_Noisy_Im(nome,nois,IB)
% true image
I = imread(nome);
I=im2double(I);
switch IB
    case '1K'
%==========================================================================
%   TEST one kernel
%--------------------------------------------------------------------------
      hsize=11; sigma=7; ZZ=fspecial('gaussian',hsize,sigma);
      ZZ = ZZ / sum(ZZ(:));
        Htmp = cell(1,9);
        Htmp{1} = ZZ;
        Htmp{2} = ZZ;
        Htmp{3} = ZZ;
        Htmp{4} = ZZ;
        Htmp{5} = ZZ;
        Htmp{6} = ZZ;
        Htmp{7} = ZZ;
        Htmp{8} = ZZ;
        Htmp{9} = ZZ;
%         
% weights assigned to each kernel
%
        r = [ .7 .15 .15;
             .1 .8 .1;
             .2 .2 .6];    
        % kernel
        H = cell(3,3);
        R=[5     6     9     7     4     1     8     2     3];

    case '9K'
        len = 21; theta = 45;
        len2 = 41; theta2 = 90;
        len3 = 61; theta3 = 135;
        
        hsize = 7; sigma = 5;
        hsize2 = 9; sigma2 = 5;
        hsize3 = 11; sigma3 = 5;
        
        ahsize = 13;
        ahsize2 = 15;
        ahsize3 = 17;
        
        % 9 kernels
        Htmp = cell(1,9);
        Htmp{1} = fspecial('motion',len,theta);
        Htmp{2} = fspecial('motion',len2,theta2);
        Htmp{3} = fspecial('motion',len3,theta3);
        Htmp{4} = fspecial('gaussian',hsize,sigma);
        Htmp{5} = fspecial('gaussian',hsize2,sigma2);
        Htmp{6} = fspecial('gaussian',hsize3,sigma3);
        Htmp{7} = fspecial('average',[ahsize, ahsize]);
        Htmp{8} = fspecial('average',[ahsize2,ahsize2]);
        Htmp{9} = fspecial('average',[ahsize3,ahsize3]);
        
        % weights assigned to each kernel
        
       r = [ .7 .15 .15;
            .1 .8 .1;
            .2 .2 .6];
end
H = cell(3,3);
R=[5     6     9     7     4     1     8     2     3];

H{1,1} = Htmp{R(1)}; H{1,2} = Htmp{R(2)}; H{1,3} = Htmp{R(3)};
H{2,1} = Htmp{R(4)}; H{2,2} = Htmp{R(5)}; H{2,3} = Htmp{R(6)};
H{3,1} = Htmp{R(7)}; H{3,2} = Htmp{R(8)}; H{3,3} = Htmp{R(9)};
        
H{1,1} = r(1,1).*H{1,1}; H{1,2} = r(1,2).*H{1,2}; H{1,3} = r(1,3).*H{1,3};
H{2,1} = r(2,1).*H{2,1}; H{2,2} = r(2,2).*H{2,2}; H{2,3} = r(2,3).*H{2,3};
H{3,1} = r(3,1).*H{3,1}; H{3,2} = r(3,2).*H{3,2}; H{3,3} = r(3,3).*H{3,3};                
        %
        %------------------------------------------------------------------
        % Computation of the eigenvalues
        %-----------------------------------------------------------------
[N,M,K]=size(I);
LAMBDA=cell(3,3);
off=0;
for i=1:3
   for j=1:3
        P=H{i,j};
        [mm, nn] = find(P == max(P(:)));C= [mm(1), nn(1)];
         Pbig = zeros(N+2*off, M+2*off);
         Pbig(1:size(P,1), 1:size(P,2)) = P;
         LAMBDA{i,j} = fft2(circshift(Pbig, 1-C));  % Eigenvalue of big PSF.
         Center{i,j}=C;
    end
end
% 
% Blur Image
%     
B_blur=imfilter33(I,H,'conv');
snrBn = snr(B_blur,I);
v=randn(size(B_blur)); Bn = B_blur + nois*v;
%
% par structure
%
par.H=H;
par.LAMBDA=LAMBDA;
par.Center=Center;
par.off=off;
par.snrbl=snrBn;
par.sol_true=I;


